<template>
  <div class="gp-month-flags-input" :class="componentCSS">
    <label v-for="index in 12" :key="index">
      <input v-model="inputs[index-1]"
             type="checkbox"
             :name="`${inputName}[${index}]`"
             @change="handleChange">
      {{ months[index-1] }}
    </label>
  </div>
</template>

<script>
import { randomString } from '@experiments-labs/rise_ui/src/lib/String.js'
import { filledArray } from '../../../../helpers/Arrays'

const formats = ['integers', 'booleans']

/**
 * Form input for month selection
 *
 * @noPlayground This component needs an array as input.
 */
export default {
  name: 'GpMonthFlagsInput',
  emits: [
    /**
     * Triggered when user changes a value
     *
     * @param {boolean[] | number[]} value - New months set
     */
    'update:modelValue',
  ],
  props: {
    /** Model value. Ignore when using `v-model` */
    modelValue: { required: false, type: Array, default: () => filledArray(12, false) },
    /** Display the months vertically */
    vertical: { required: false, type: Boolean, default: false },
    /**
     * Input/output format.
     * - `booleans` needs an array of booleans (i.e.: `[true, true, false,...]`)
     * - `integers` needs an array of integers (i.e.: `[1,2,11,12]`)
     */
    format: { required: false, type: String, default: 'booleans', validator: v => formats.includes(v) },
    /** Whether to display the full month names */
    fullMonths: { required: false, type: Boolean, default: false },
    /** Prefix for `id` attribute of Inputs */
    inputId: { required: false, type: String, default: () => randomString() },
    /** Prefix for `name` attribute of Inputs */
    inputName: { required: true, type: String },
  },
  data () {
    return {
      inputs: this.convertInputs(),
    }
  },
  computed: {
    months () {
      let strings = this.fullMonths ? this.$tm('date.month_names') : this.$tm('date.abbr_month_names')
      strings = [...strings]
      strings.shift()
      return strings
    },
    componentCSS () {
      return [
        this.vertical && 'gp-month-flags-input--vertical',
      ]
    },
  },
  methods: {
    /**
     * Handles internal changes and emits the updated list
     */
    handleChange () {
      let values = []
      // Convert internal state to desired format
      if (this.$props.format === 'integers') {
        this.inputs.forEach((value, index) => {
          if (value) values.push(index + 1)
        })
      } else { values = [...this.inputs] }

      if (values.toString() === this.$props.modelValue.toString()) return
      this.$emit('update:modelValue', values)
    },
    /**
     * Converts input array to an array of booleans
     *
     * @returns {boolean[]} List to use in template
     */
    convertInputs () {
      if (this.format === 'integers') {
        const list = filledArray(12, false)
        this.$props.modelValue.forEach(v => { list[v - 1] = true })
        return list
      }

      return [...(this.$props.modelValue || filledArray(12, false))]
    },
  },
  watch: {
    // Handle external changes
    modelValue (newValue) {
      if (this.inputs.toString() === newValue.toString()) return
      this.inputs = this.convertInputs()
    },
  },
}
</script>
